# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_check_curve.m
# input: A matrix of the type
#        A {a1 a2 an}
#        where ai = [xi, yi, si]
#       
# output true if curve is consistent false otherwise
#
###########################################
function ok = sla_check_curve(A)
  ok = true ;
  for (i = 1: size(A, 2))
    if (abs(A{i}(2)) < 1.0e-12)
      A{i}(2) = 0 ;
    end
    if (abs(A{i}(1)) < 1.0e-12)
      A{i}(1) = 0 ;
    end 
    if (A{i}(2) < 0.0 || A{i}(1) < 0.0)
      ok = false ;
      break ;
    end 
    if (i > 1) 
      if (A{i-1}(1) > A{i}(1))
        ok = false ;
        break ;
      end
   end
  end
endfunction
