# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_check_xy.m
# input: x, y x and y values of a curve
#       
# output true if the x and y segments define a curve
#            at least two segements x non decreasing
#
###########################################
function b = sla_check_xy (x, y)

   b = true ;
   if (length(x) < 2)
      b = false ;
   else
      for (i=2:length(x))
         if (x(i) < 0)
	   x(i) = 0 ;
	 endif
         if(x(i) > 0 && (x(i) - x(i-1)) / x(i) < -1.0e-6)
	    b = false ;
	    break ;
	 endif
	 if (x(i) < x(i-1))
	   x(i) = x(i-1) ;
	 endif
      endfor
   endif
endfunction