# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_concatenated_system.m
# input: Sys1, Sys2 subsystem to be concatenated
#          
# output Sys
#
# description: The function generates a serial concatenation
#              of two systems. 
#
###########################################
function Sys = sla_concatenated_system(Sys1, Sys2)

  Sys.type = 'c' ;
  Sys.Subsys1 = Sys1 ;
  Sys.Subsys2 = Sys2 ;
   
endfunction