# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_derivative.m
# input: A matrix of the type
#        A {a1 a2 an}
#        where ai = [xi, yi, si]
#       
# output: AD curve that describes the derivative of A
#
###########################################
function AD = sla_derivative(A)
  if sla_check_curve(A)
     AD = A ;
     for (i=1:columns(A))
     	 AD{i}(2) = A{i}(3) ;
	 AD{i}(3) = 0 ;
     endfor
  else
    printf("Sorry, curve specification inconsistent\n") ;    
  endif
endfunction