# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_is_smaller_or_equal.m
# input: A, B matrices of the type
#        A {a1 a2 an}
#        where ai = [xi, yi, si]
#       
# output true if the final rate of curve A s smaller or equal
#             than the final rate of curve B
#
###########################################
function ok = sla_has_smaller_rate(A, B)

   if (A{columns(A)}(3) >  B{columns(B)}(3))
      ok = false ;
   else
      ok = true ;
   endif
  return ;
endfunction