# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_is_equal.m
# input: A, B matrices of the type
#        A {a1 a2 an}
#        where ai = [xi, yi, si]
#       
# output true if the curves are equal
#
###########################################
function ok = sla_is_equal(A, B)

  A = sla_reduce(A) ;
  B = sla_reduce(B) ;
  if (columns(A) != columns(B))
    ok = false ;
    return ;
  endif
  for (i = 1: columns(A))
     if (abs(A{i}(1)-B{i}(1)) > 1.0e-8 || abs(A{i}(2)-B{i}(2)) > 1.0e-8 || abs(A{i}(3)-B{i}(3)) > 1.0e-8)
        ok = false ;
       	return ;
    endif		
  endfor
  ok = true ;
  return  ;
endfunction