# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_is_increasing.m
# input: A matrix of the type
#        A {a1 a2 an}
#        where ai = [xi, yi, si]
#       
# output true if curve is increasing false otherwise
#
###########################################
function ok = sla_is_increasing(A)

  for (i = 1: columns(A)-1)
     y = (A{i+1}(1)-A{i}(1))*A{i}(3) + A{i}(2) ;
     if (y - A{i+1}(2) > 1.0e-2 || A{i}(3) < 0)
        ok = false ;
       	return ;
    endif		
  endfor
  ok = true ;
  return  ;
endfunction