# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_max
#
# input: A, B matrices of the type
#        A {a1 a2 an}
#        where ai = [xi, yi, si]
#
# output C = max(A, B)
#
###########################################
function C = sla_max(A, B)

   A = sla_add_zero(A) ;
   B = sla_add_zero(B) ;
   for (i = 1:columns(A))
      A{i}(2) = -A{i}(2) ;
      A{i}(3) = -A{i}(3) ;
   endfor
   for (i = 1:columns(B))
      B{i}(2) = -B{i}(2) ;
      B{i}(3) = -B{i}(3) ;
   endfor
   C = sla_min(A, B) ;
   for (i = 1:columns(C))
      C{i}(2) = -C{i}(2) ;
      C{i}(3) = -C{i}(3) ;
   endfor

endfunction