# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_mult_constant.m
# input: A matrix of the type
#        A {a1 a2 an}
#        where ai = [xi, yi, si]
#        c constant to be multiplied
#       
# output B = c*A
#
###########################################
function B = sla_mult_constant(A, c)
  B = A ;
  for (i = 1: columns(B))
     B{i}(2) *= c ;
     B{i}(3) *= c ;
  endfor
  B = sla_reduce(B) ;
endfunction