# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_non_negative
#
# input: A matrix of the type
#        A {a1 a2 an}
#        where ai = [xi, yi, si]
#
# output C matrix of the curve where negative parts are ste to 0 
#
# 
#
###########################################
function B = sla_non_negative(A)

   B = A ;
   neg = false ;
   for (i=1:columns(A))
      if (A{i}(2) < 0)
         neg = true ;
	 break ;
      endif
      if (A{i}(3) < 0)
         if (i == columns(A))
	    neg = true ;
	    break ;
	 else
	    if (A{i}(2)-A{i}(3)*(A{i+1}(1)-A{i}(1))<0)
	       neg = true ;
	       break ;
	    endif
	 endif
      endif
   endfor
   if (neg)
      j = 1 ;
      for (i=1:columns(A))
         if (A{i}(2) >= 0 && A{i}(3) >= 0)
	    B{j} = A{i} ;
	    j++ ;
	 else
	    if (A{i}(2) >= 0)
	       B{j} = A{i} ;
	       j++ ;
	       x = A{i}(1)- A{i}(2)/A{i}(3) ;
	       y = 0 ;
	       s = 0 ;
	       B{j} = [x, y, s] ;
	       j++ ;
            else
	       B{j} = [A{i}(1), 0, 0] ;
	       j++ ;
	       if (A{i}(3) > 0)
	          x = A{i}(1) - A{i}(2)/A{i}(3) ;
		  y = 0 ;
		  s = A{i}(3) ;
		  if (i == columns(A) || x < A{i+1}(1))
		     B{j} = [x, y, s] ;
		     j++ ;
		  endif
	       endif
	    endif
	 endif
      endfor
   endif

endfunction