# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_reduce.m
# input: A matrix of the type
#        A {a1 a2 an}
#        where ai = [xi, yi, si]
#       
# output B matrix where unnecessary segments
#          are removed
#
###########################################
function B = sla_reduce(A)

   B = {A{1}} ;
   j = 1 ;
   if (B{1}(3) != Inf)
      for (i=2:columns(A))
         if (A{i}(1)-1.0e-6 > A{i-1}(1))
	    j++ ;
         endif
         B{j} = A{i} ;
         if (B{j}(3) == Inf)
            break ;
         endif
      endfor
   endif
   A = B ;
   red = false ;
   for (i = 1:columns(A)-1)	
      if (abs(A{i+1}(2)-A{i}(2)-(A{i+1}(1)-A{i}(1))*A{i}(3))/(A{i+1}(1)-A{i}(1)) < 1.0e-8 && abs(A{i}(3)-A{i+1}(3)) < 1.0e-6)
         red = true ;
         break ;
      endif
   endfor 
   if (red)
      b = [A{1}(1), A{1}(2), A{1}(3)] ;
      B = {b} ;
      j = 2 ;
      for (i=1:columns(A)-1)
         if (abs(A{i+1}(2)-A{i}(2)-(A{i+1}(1)-A{i}(1))*A{i}(3))/(A{i+1}(1)-A{i}(1)) >= 1.0e-8 || abs(A{i}(3)-A{i+1}(3))>= 1.0e-6)
	    b = [A{i+1}(1), A{i+1}(2), A{i+1}(3)] ;
	    B{j} = b ;
            j++ ; 
         endif
      endfor
   endif

endfunction