# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_shift_curve
#
# input: A curve
#        xadd increment of x
#
# output B(x) = A(x+xadd)
#
###########################################
function B = sla_shift_curve(A, xadd)

  for (i=1:columns(A))
    if (A{i}(1) >= xadd)
      i-- ;
      break ;
    endif
  endfor
  yval = (xadd-A{i}(1))*A{i}(3)+A{i}(2) ;
  sval = A{i}(3) ;
  B = {[0, yval, sval]} ;
  for (j=i+1:columns(A))
    B{j-i+1} = [A{j}(1)-xadd, A{j}(2), A{j}(3)] ;
  endfor

endfunction