# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_split_delay
#
# input: A curve
#        p multiplicative part
#        b additive part 
#
# output Delay curve B is p*x-b is routed to the service
#
###########################################
function C = sla_split_delay(A, p, b)

   if (p > 0)
      B = sla_add_zero(A) ;
      B{1}(3) *= p ;
      for (i=2:columns(B))
         B{i}(1) /= p ;
	 B{i}(3) *= p ;
      endfor
   else
      B = {[0, A{1}(2), 0]} ;
   endif
   if (b <= 0)
      C = B ;
   else
      C = {[0, B{1}(2), 0]} ;
      for (i=1:columns(B))
        C{i+1} = [B{i}(1)+b, B{i}(2), B{i}(3)] ;
      endfor
   endif
   C = sla_reduce(C) ;

endfunction