# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#####################################
# Copyright (c) 2016 Peter Buchholz #
#####################################
############################################
#
# sla_curve_to_xy.m
# input: x, y coordinates of a curve
#       
# output A matrix description of a curve
#
###########################################
function A = sla_xy_to_curve(x, y)
  leng = length(x) ;
  if (leng > 1)
    i = 1 ;
    j = 1 ;
    while (i < leng)
      if (x(i) < x(i+1))
        xval = x(i) ;
	yval = y(i) ;
        sval = (y(i+1) - y(i)) / (x(i+1)-x(i)) ;
	a = [xval, yval, sval] ;
        i++ ;
	if (j > 1)
	  A(j) = a ;
        else
	  A = {a} ;
	endif
	j++ ;
      else
        i++ ;
      endif
    endwhile
  else
    # the curve is a straight line
    A = {[0, y(1), 0]} ;    
  endif
endfunction